ArrayList points;
ArrayList getPoints() { return points; }
center_x = 300;
center_y = 300;
int last_day = 2;
radius = 5;

void setup() {
     size(800,800);
     points = new ArrayList();
     noLoop();
     stroke(255,0,0);
     fill(255);
}
 
void draw() {
     stroke(255,255,255,128);
     noFill();
     //rings
     ellipse(center_x,center_y,2,2);
     ellipse(center_x,center_y,100,100);
     ellipse(center_x,center_y,200,200);
     ellipse(center_x,center_y,300,300);
     ellipse(center_x,center_y,400,400);
     ellipse(center_x,center_y,500,500);
     //weather bars	
	 for(int i=0; i<(points.size()-1); i++) {
		drawDay(i, 2);
    }
}

void mouseClicked() {
	if(mouseX < 100 && mouseY < 100) {
		background(200,200,200);
		clearPoints();
	}
}
    	
void mouseMoved(mX, mY) {
	if(mX < 800 && mY < 800) {
		float angle1 = atan2(0 - 300, 400 - 300);
    	float angle2 = atan2(mY - 300, mX - 300);
    	float d = degrees(angle2 - angle1);
		updateText(d, mY, true);
	}
}    	
    	
void updateText(d, depth, need_update) {
	fill(200,200,200);
	noStroke();
	ellipse(center_x,center_y,180,180);
	fill(255,255,0);
	stroke(255,255,0);
    while(d < 0) {
    	d += 360;
    }
    d = d * 365/360;
	last_day = floor(d);
	int day = floor(d)+1;
	var month = "Jan";
	Point pt = (Point) points.get(day-1);
	Point pt_tot = (Point) points.get(365);
	if(d>334) {
		month = "Dec";
		day = day-334;
	} else if(d>304) {
		month = "Nov";
		day = day-304;
	} else if(d>274) {
		month = "Oct";
		day = day-274;
	} else if(d>243) {
		month = "Sep";
		day = day-243;
	} else if(d>212) {
		month = "Aug";
		day = day-212;
	} else if(d>181) {
		month = "Jul";
		day = day-181;
	} else if(d>151) {
		month = "Jun";
		day = day-151;
	} else if(d>120) {
		month = "May";
		day = day-120;
	} else if(d>90) {
		month = "Apr";
		day = day-90;
	} else if(d>59) {
		month = "Mar";
		day = day-59;
	} else if(d>31) {
		month = "Feb";
		day = day-31;
	}
	fill(255,255,0);
	textSize(24);
	text(month + " " + day, 260, 240);
	textSize(18);
	fill(255,0,0);
	text("Work: " + pt.a + " - " + (floor(pt_tot.a/3.65)/100), 238, 264);
	fill(255,255,255);
	text("Sport: " + pt.f + " - " + (floor(pt_tot.f/3.65)/100), 238, 281);
	fill(0,255,255);
	text("Teach: " + pt.c + " - " + (floor(pt_tot.c/3.65)/100), 238, 298);
	fill(255,255,0);
	text("Study: " + pt.d + " - " + (floor(pt_tot.d/3.65)/100), 238, 316);
	fill(188,0,188);
	text("Travel: " + pt.e + " - " + (floor(pt_tot.e/3.65)/100), 238, 334);
	fill(0,255,0);
	text("Leisure: " + pt.g + " - " + (floor(pt_tot.g/3.65)/100), 238, 350);
	fill(0,0,255);
	text("Sleep: " + pt.b + " - " + (floor(pt_tot.b/3.65)/100), 238, 368);
}
 
Point addPoint(float a, float b, float c, float d, float e, float f, float g) {
	Point pt = new Point(a,b,c,d,e,f,g);
	points.add(pt);
	return pt;
}

void clearPoints() {
	points = new ArrayList();
}

void drawDay(int i, int thickness) {
	 	Point pt = (Point) points.get(i);
    	angle = radians(((i/(points.size()-1)) * 360) - 90);
    	stroke(255,0,0);
    	strokeWeight(thickness);
	    float x = center_x + (cos(angle)*100);
    	float y = center_y + (sin(angle)*100);
    	float xx = center_x + (cos(angle)*(100+radius*pt.a));
    	float yy = center_y + (sin(angle)*(100+radius*pt.a));
    	var cumulative = pt.a;
    	//draw work line
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.f)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.f)));
    	cumulative += pt.f;
    	//draw sport line
    	stroke(255,255,255);
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.c)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.c)));
    	cumulative += pt.c;
    	//draw teach line
    	stroke(255,255,0);
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.d)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.d)));
    	cumulative += pt.d;
    	//draw study line
    	stroke(0,255,255);
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.e)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.e)));
    	cumulative += pt.e;
    	//draw travel line
    	stroke(188,0,188);
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.g)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.g)));
    	cumulative += pt.g;
    	//draw leisure line
    	stroke(0,255,0);
    	line(x, y, xx, yy);
	    float x = center_x + (cos(angle)*(101+radius*(cumulative)));
    	float y = center_y + (sin(angle)*(101+radius*(cumulative)));
    	float xx = center_x + (cos(angle)*(100+radius*(cumulative+pt.b)));
    	float yy = center_y + (sin(angle)*(100+radius*(cumulative+pt.b)));
    	//draw sleep line
    	stroke(0,0,255);
    	line(x, y, xx, yy);
}
    
class Point {
     float a,b,c,d,e,f,g;
     Point(float a, float b, float c, float d, float e, float f, float g) { this.a=a; this.b=b; this.c=c; this.d=d; this.e=e; this.f=f; this.g=g; }
     void draw() { ellipse(x,y,10,10); }
}